import java.io.FileNotFoundException;

/**
 * 
 */

/**
 * @author nieminen
 *
 */
public class DemoIris {

    /**
     * @param args
     * @throws FileNotFoundException 
     */
    public static void main(String[] args) throws FileNotFoundException {
        DataSet iris = DataSet.createFromTextFile("iris_numerical.dat",5);
        
        // Make the split to training and testing sets. Ex. 0.4=40%/60%
        iris.shuffledSplitToTrainAndTest(.4);

        int[] layerSizes = new int[]{
                iris.getVecSize(), 3, iris.getNumOfClasses() };

        SimpleMLP mlp = new SimpleMLP(layerSizes);

        for(int i=0;i<100;i++){
            mlp.trainGD(iris.trainInputs(), iris.trainTargets(), 0.1, 100);

            System.out.println("Training set:");
            int[] outclasses = mlp.classifyMatrix(iris.trainInputs());
            DataSet.printConfusion(outclasses,iris.trainTargets());

            System.out.println("Test set:");
            outclasses = mlp.classifyMatrix(iris.testInputs());
            DataSet.printConfusion(outclasses,iris.testTargets());
        }
    }
}
